Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 582130 - dev-libs/libxml2[python] - cross-compiling fails with "error: #error "LONG_BIT definition appears wrong for platform (bad gcc/glibc config?)."
Summary: dev-libs/libxml2[python] - cross-compiling fails with "error: #error "LONG_BI...
Status: CONFIRMED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Sam James
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2016-05-05 04:30 UTC by Peter Levine
Modified: 2021-12-02 19:05 UTC (History)
7 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
dev-libs-libxml2-2.9.3-20160505-041611.log (dev-libs:libxml2-2.9.3:20160505-041611.log,155.50 KB, text/x-log)
2016-05-05 04:33 UTC, Peter Levine
Details
emerge-armv7a-hardfloat-linux-gnueabi --info (emerge-armv7a-hardfloat-linux-gnueabi-info.txt,14.63 KB, text/plain)
2016-05-05 04:34 UTC, Peter Levine
Details
Patch for libxml2-2.9.3.ebuild (libxml2-2.9.3.ebuild.patch,495 bytes, patch)
2016-05-05 04:57 UTC, Peter Levine
Details | Diff
build.log (build.log,116.88 KB, text/plain)
2020-11-01 00:57 UTC, Sven E.
Details
Cross Compile Build Log (build-.hppa.log,117.17 KB, text/x-log)
2021-04-07 10:47 UTC, Roy Bamford
Details
Cross Compile libxml2-2.9.10-.hppa/config.log (config.log,100.03 KB, text/x-log)
2021-04-07 10:54 UTC, Roy Bamford
Details
libxml2-2.9.10-.hppa-python3_8/config.log (config.log,100.55 KB, text/x-log)
2021-04-07 10:55 UTC, Roy Bamford
Details
build.log (build.log,135.58 KB, text/plain)
2021-04-08 13:19 UTC, tgyt
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Peter Levine 2016-05-05 04:30:28 UTC
Cross-compiling dev-libs/libxml2-2.9.3 or dev-libs/libxml2-2.9.2-r4 (CBUILD=x86_64-pc-linux-gnu and CHOST=armv7a-hardfloat-linux-gnueabi) fails with "error: #error "LONG_BIT definition appears wrong for platform (bad gcc/glibc config?)."

It seems to end up using the CBUILD's python headers instead of the CHOST's.
Comment 1 Peter Levine 2016-05-05 04:33:27 UTC
Created attachment 433250 [details]
dev-libs-libxml2-2.9.3-20160505-041611.log
Comment 2 Peter Levine 2016-05-05 04:34:37 UTC
Created attachment 433252 [details]
emerge-armv7a-hardfloat-linux-gnueabi --info
Comment 3 Peter Levine 2016-05-05 04:35:18 UTC
Likely also related to https://bugs.gentoo.org/show_bug.cgi?id=379201
Comment 4 Peter Levine 2016-05-05 04:57:03 UTC
Created attachment 433254 [details, diff]
Patch for libxml2-2.9.3.ebuild

$PYTHON gets set to the build's "${EPREFIX}/usr/bin/pythonX.Y" which is correct since python-utils-r1.eclass (inherited from python-r1.eclass) has to execute it.  However, that gets passed to the configure as "--with-python=${EPREFIX}/usr/bin/pythonX.Y" which provides the wrong include paths.  Fortunately, if passed the host's python (i.e., "--with-python=${ROOT%/}${PYTHON}") it appears libxml2 doesn't execute the cross-compiled python and is able to deduce the correct python paths.
Comment 5 Peter Levine 2016-05-05 05:01:38 UTC
Also, the same line in the patch can be applied to, and works for, libxml2-2.9.2-r4.ebuild
Comment 6 Peter Levine 2016-05-05 05:08:01 UTC
Also, it should be noted that this type of error is known to arise when the CBUILD is a 64-bit arch and the CHOST is a 32-bit arch (and quite possibly vice-versa).  It may not be reproducible when both the host and arch CPU have the same word size.
Comment 7 Peter Levine 2016-05-05 05:09:26 UTC
(In reply to Peter Levine from comment #6)
> It may not be reproducible when both the host and arch CPU
> have the same word size.

I meant, it may not be reproducible when both the host and build CPU have the same word size.
Comment 8 Pacho Ramos gentoo-dev 2016-05-29 10:49:43 UTC
fixed in 2.9.4
Comment 9 Sven E. 2020-11-01 00:57:23 UTC
Created attachment 669506 [details]
build.log

build.log for failing build
Comment 10 Sven E. 2020-11-01 00:58:17 UTC
I'm seeign the exact same failure cross building for ARM with dev-libs/libxml2-2.9.10-r3
Comment 11 tgyt 2021-04-01 09:02:01 UTC
Still exists at 2.9.10-r4
Comment 12 Sam James archtester gentoo-dev Security 2021-04-02 08:50:00 UTC
(In reply to tgyt from comment #11)
> Still exists at 2.9.10-r4

Please attach the full build.log and emerge —-info.
Comment 13 Roy Bamford gentoo-dev 2021-04-07 10:39:48 UTC
Still present in dev-libs/libxml2-2.9.10-r5.

This example is from building on a 64 bit CHOST, amd64, for a 32 bit hppa-unknown-linux-gnu target.

# hppa-unknown-linux-gnu-emerge --info
Portage 3.0.18 (python 3.8.8-final-0, default/linux/hppa/17.0, gcc-10.2.0, glibc-2.32-r8, 5.11.2-gentoo x86_64)
=================================================================
System uname: Linux-5.11.2-gentoo-x86_64-AMD_Phenom-tm-_II_X6_1090T_Processor-with-glibc2.2.5
KiB Mem:    16396360 total,  11819668 free
KiB Swap:    2088432 total,   2088432 free
Timestamp of repository gentoo: Tue, 30 Mar 2021 10:45:01 +0000
Head commit of repository gentoo: d23ad8c40a3f96a1da26b525a254ee540a76473c
sh bash 5.1_p4
ld GNU ld (Gentoo 2.35.2 p1) 2.35.2
distcc 3.3.3 x86_64-pc-linux-gnu [disabled]
app-shells/bash:          5.1_p4::gentoo
dev-lang/python:          3.8.8::gentoo
sys-apps/baselayout:      2.7-r1::gentoo
sys-apps/openrc:          0.42.1-r1::gentoo
sys-apps/sandbox:         2.22::gentoo
sys-devel/binutils:       2.35.2::gentoo
sys-devel/gcc:            10.2.0-r5::gentoo
sys-devel/gcc-config:     2.4::gentoo
sys-devel/make:           4.3::gentoo
sys-kernel/linux-headers: 5.11::gentoo (virtual/os-headers)
sys-libs/glibc:           2.32-r8::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://rsync.gentoo.org/gentoo-portage
    priority: -1000
    sync-rsync-verify-jobs: 1
    sync-rsync-verify-metamanifest: yes
    sync-rsync-verify-max-age: 24
    sync-rsync-extra-opts: 

ACCEPT_KEYWORDS="hppa ~hppa"
ACCEPT_LICENSE="@FREE"
CBUILD="x86_64-pc-linux-gnu"
CC="/usr/x86_64-pc-linux-gnu/hppa-unknown-linux-gnu/gcc-bin/10.2.0/hppa-unknown-linux-gnu-gcc"
CFLAGS="-O2 -pipe -fomit-frame-pointer"
CHOST="hppa-unknown-linux-gnu"
CONFIG_PROTECT="/etc /usr/lib64/libreoffice/program/sofficerc /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXX="/usr/x86_64-pc-linux-gnu/hppa-unknown-linux-gnu/gcc-bin/10.2.0/hppa-unknown-linux-gnu-c++"
CXXFLAGS="-O2 -pipe -fomit-frame-pointer"
DISTDIR="/usr/portage/distfiles"
ENV_UNSET="CARGO_HOME DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN GOPATH PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS=""
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs buildpkg config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync multilib-strict network-sandbox news nodoc noinfo noman parallel-fetch pid-sandbox preserve-libs protect-owned qa-unresolved-soname-deps sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS=""
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="en_GB.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j8"
PKGDIR="/usr/hppa-unknown-linux-gnu/packages/"
PORTAGE_CONFIGROOT="/usr/hppa-unknown-linux-gnu/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/usr/hppa-unknown-linux-gnu/tmp/"
USE="acl berkdb big-endian bzip2 cli crypt cups firefox foomaticdb fortran gdbm gpm hppa iconv imlib ipv6 libglvnd libwww ncurses nls nptl openmp pcre readline seccomp spell split-usr ssl tcpd unicode xattr zlib" ADA_TARGET="gnat_2018" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock greis isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="libinput" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LUA_SINGLE_TARGET="lua5-1" LUA_TARGETS="lua5-1" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-3 php7-4" POSTGRES_TARGETS="postgres10 postgres11" PYTHON_SINGLE_TARGET="python3_8" PYTHON_TARGETS="python3_8" RUBY_TARGETS="ruby26" USERLAND="GNU" VIDEO_CARDS="fbdev dummy v4l" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq proto steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LC_ALL, LINGUAS, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 14 Sam James archtester gentoo-dev Security 2021-04-07 10:46:59 UTC
build.log? possibly config.log too?
Comment 15 Roy Bamford gentoo-dev 2021-04-07 10:47:59 UTC
Created attachment 698175 [details]
Cross Compile Build Log

Cross compiling portage ends with the same error.
Comment 16 Roy Bamford gentoo-dev 2021-04-07 10:54:19 UTC
Created attachment 698178 [details]
Cross Compile libxml2-2.9.10-.hppa/config.log
Comment 17 Roy Bamford gentoo-dev 2021-04-07 10:55:44 UTC
Created attachment 698181 [details]
libxml2-2.9.10-.hppa-python3_8/config.log
Comment 18 tgyt 2021-04-08 13:19:11 UTC
Created attachment 698544 [details]
build.log

Portage 3.0.13 (python 3.8.7-final-0, default/linux/arm/17.0/armv7a, gcc-9.3.0, glibc-2.32-r7, 5.10.14-gentoo x86_64)
=================================================================
System uname: Linux-5.10.14-gentoo-x86_64-Intel-R-_Core-TM-_i5-2500_CPU_@_3.30GHz-with-glibc2.2.5
KiB Mem:    16284740 total,   6861536 free
KiB Swap:    6291452 total,   6291452 free
Timestamp of repository gentoo: Mon, 08 Mar 2021 14:30:01 +0000
Head commit of repository gentoo: 72f46324360c240e6d23fd19ce3386ff9e1ea55d
sh bash 5.0_p18
ld GNU ld (Gentoo 2.34 p6) 2.34.0
distcc 3.3.3 x86_64-pc-linux-gnu [disabled]
app-shells/bash:          5.0_p18::gentoo
dev-lang/python:          3.8.7-r1::gentoo
dev-util/cmake:           3.18.5::gentoo
sys-apps/baselayout:      2.7::gentoo
sys-apps/openrc:          0.42.1-r1::gentoo
sys-apps/sandbox:         2.20::gentoo
sys-devel/binutils:       2.35.1-r1::gentoo
sys-devel/gcc:            9.3.0-r2::gentoo
sys-devel/gcc-config:     2.3.2-r1::gentoo
sys-devel/make:           4.3::gentoo
sys-kernel/linux-headers: 5.11::gentoo (virtual/os-headers)
sys-libs/glibc:           2.32-r7::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://rsync.gentoo.org/gentoo-portage
    priority: -1000
    sync-rsync-verify-metamanifest: yes
    sync-rsync-extra-opts: 
    sync-rsync-verify-max-age: 24
    sync-rsync-verify-jobs: 1

ACCEPT_KEYWORDS="arm"
ACCEPT_LICENSE="@FREE"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -pipe -mcpu=cortex-a8 -mfpu=neon-vfpv3 -mfloat-abi=hard --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=256 -ffast-math"
CHOST="armv7a-unknown-linux-gnueabihf"
CONFIG_PROTECT="/etc /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/gconf /etc/gentoo-release /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -pipe -mcpu=cortex-a8 -mfpu=neon-vfpv3 -mfloat-abi=hard --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=256 -ffast-math"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS="-a --buildpkg-exclude "virtual/* acct-*/* sys-kernel/*-sources""
ENV_UNSET="CARGO_HOME DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN GOPATH PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-O2 -pipe -march=armv7-a"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs buildpkg config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync multilib-strict network-sandbox news nodoc noinfo noman parallel-fetch pid-sandbox preserve-libs protect-owned qa-unresolved-soname-deps sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync"
FFLAGS="-O2 -pipe -march=armv7-a"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="ru_RU.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j4"
PKGDIR="/usr/armv7a-unknown-linux-gnueabihf/packages/"
PORTAGE_CONFIGROOT="/usr/armv7a-unknown-linux-gnueabihf/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/usr/armv7a-unknown-linux-gnueabihf/tmp/"
USE="acl arm berkdb bzip2 cli crypt dri gdbm iconv ipv6 libglvnd lto ncurses nls nptl pam pcre readline split-usr ssl tcpd unicode xa zlib zstd" ADA_TARGET="gnat_2018" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_ARM="edsp thumb thumb2 v4 v5 v6 v7 vfp" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock greis isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="libinput" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LUA_SINGLE_TARGET="lua5-1" LUA_TARGETS="lua5-1" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-3 php7-4" POSTGRES_TARGETS="postgres10 postgres11" PYTHON_SINGLE_TARGET="python3_8" PYTHON_TARGETS="python3_8" RUBY_TARGETS="ruby26" USERLAND="GNU" VIDEO_CARDS="lima" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, LINGUAS, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 19 ShorTie 2021-04-09 11:44:30 UTC
I know stupid me, but what I see is
"sys-kernel/linux-headers: 5.11::gentoo (virtual/os-headers)"
and wonder if glibc has been compiled using those headers ??

Also seems gcc is a little behind too...
System update in order maybe ??
But what do I know .. :/~
Comment 20 tgyt 2021-04-09 21:46:17 UTC
It compiles with
EXTRA_ECONF="--with-python=/usr/armv7a-unknown-linux-gnueabihf/${PYTHON}"
in env. AFAIK this shouldn't work, but it does.
Comment 21 Sam James archtester gentoo-dev Security 2021-04-09 21:56:25 UTC
(In reply to tgyt from comment #20)
> It compiles with
> EXTRA_ECONF="--with-python=/usr/armv7a-unknown-linux-gnueabihf/${PYTHON}"
> in env. AFAIK this shouldn't work, but it does.

Can you try modifying the ebuild?

diff --git a/dev-libs/libxml2/libxml2-2.9.10-r5.ebuild b/dev-libs/libxml2/libxml2-2.9.10-r5.ebuild
index 97ea995cd04..4c857ac5aaf 100644
--- a/dev-libs/libxml2/libxml2-2.9.10-r5.ebuild
+++ b/dev-libs/libxml2/libxml2-2.9.10-r5.ebuild
@@ -147,7 +147,7 @@ multilib_src_configure() {

                # Odd build system, also see bug #582130
                run_in_build_dir libxml2_configure \
-                       "--with-python=${EPYTHON}" \
+                       "--with-python=${BROOT}/${EPYTHON}" \
                        "--with-python-install-dir=$(python_get_sitedir)"
        }
Comment 22 Mike Gilbert gentoo-dev 2021-04-09 22:44:59 UTC
I think the configure script would need to be modified to properly support cross-compiling with python bindings enabled.

It executes the program specified by --with-python to figure out the python version and some paths. This cannot work if the python binary has been compiled for another architecture.

It should probably use something like pkg-config instead.
Comment 23 Roy Bamford gentoo-dev 2021-04-10 12:45:11 UTC
(In reply to Sam James from comment #21)
> (In reply to tgyt from comment #20)
> > It compiles with
> > EXTRA_ECONF="--with-python=/usr/armv7a-unknown-linux-gnueabihf/${PYTHON}"
> > in env. AFAIK this shouldn't work, but it does.
> 
> Can you try modifying the ebuild?
> 
> diff --git a/dev-libs/libxml2/libxml2-2.9.10-r5.ebuild
> b/dev-libs/libxml2/libxml2-2.9.10-r5.ebuild
> index 97ea995cd04..4c857ac5aaf 100644
> --- a/dev-libs/libxml2/libxml2-2.9.10-r5.ebuild
> +++ b/dev-libs/libxml2/libxml2-2.9.10-r5.ebuild
> @@ -147,7 +147,7 @@ multilib_src_configure() {
> 
>                 # Odd build system, also see bug #582130
>                 run_in_build_dir libxml2_configure \
> -                       "--with-python=${EPYTHON}" \
> +                       "--with-python=${BROOT}/${EPYTHON}" \
>                         "--with-python-install-dir=$(python_get_sitedir)"
>         }

Sam, No change, but interestingly, the EXTRA_ECONF= tweak in comment 20 works.

In file included from /usr/include/python3.8/Python.h:63,
                 from /usr/hppa-unknown-linux-gnu/tmp/portage/dev-libs/libxml2-2.9.10-r5/work/libxml2-2.9.10/python/libxml.c:14:
/usr/include/python3.8/pyport.h:726:2: error: #error "LONG_BIT definition appears wrong for platform (bad gcc/glibc config?)."
  726 | #error "LONG_BIT definition appears wrong for platform (bad gcc/glibc config?)."
Comment 24 tgyt 2021-04-10 19:29:38 UTC
> Sam, No change, but interestingly, the EXTRA_ECONF= tweak in comment 20
> works.
> 
> In file included from /usr/include/python3.8/Python.h:63,
>                  from
> /usr/hppa-unknown-linux-gnu/tmp/portage/dev-libs/libxml2-2.9.10-r5/work/
> libxml2-2.9.10/python/libxml.c:14:
> /usr/include/python3.8/pyport.h:726:2: error: #error "LONG_BIT definition
> appears wrong for platform (bad gcc/glibc config?)."
>   726 | #error "LONG_BIT definition appears wrong for platform (bad
> gcc/glibc config?)."

Same
Comment 25 tgyt 2021-04-10 19:40:20 UTC
Maybe because EPYTHON isn't full path?
Comment 26 Larry the Git Cow gentoo-dev 2021-09-24 07:23:56 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=7963aaf058ccd97431c4852244a8685056235e11

commit 7963aaf058ccd97431c4852244a8685056235e11
Author:     Jakov Smolić <jsmolic@gentoo.org>
AuthorDate: 2021-09-24 07:02:51 +0000
Commit:     Jakov Smolić <jsmolic@gentoo.org>
CommitDate: 2021-09-24 07:23:49 +0000

    dev-libs/libxml2: Fix cross-compilation with USE=python
    
    - --with-python option needs to point to the current Python intepreter on CHOST
    
    Closes: https://bugs.gentoo.org/582130
    Acked-by: Sam James <sam@gentoo.org>
    Signed-off-by: Jakov Smolić <jsmolic@gentoo.org>

 dev-libs/libxml2/libxml2-2.9.12-r5.ebuild | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)
Comment 27 Larry the Git Cow gentoo-dev 2021-09-25 09:03:18 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=dfa91850347a9ff476c06e994d6572f3492e7044

commit dfa91850347a9ff476c06e994d6572f3492e7044
Author:     Jakov Smolić <jsmolic@gentoo.org>
AuthorDate: 2021-09-25 08:59:28 +0000
Commit:     Jakov Smolić <jsmolic@gentoo.org>
CommitDate: 2021-09-25 09:03:00 +0000

    dev-libs/libxml2: Revert "Fix cross-compilation with USE=python"
    
    - Attempted soultion was wrong because the script executes Python at a
      given path which can't work if it was compiled for a different
      architecture.
    
    This reverts commit 7963aaf058ccd97431c4852244a8685056235e11.
    
    Bug: https://bugs.gentoo.org/582130
    Signed-off-by: Jakov Smolić <jsmolic@gentoo.org>

 dev-libs/libxml2/libxml2-2.9.12-r5.ebuild | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)
Comment 28 kingsley789 2021-10-30 13:20:56 UTC
This should be re-opened as it hasn't yet been properly fixed.
Comment 29 Sam James archtester gentoo-dev Security 2021-10-30 16:04:23 UTC
(In reply to kingsley789 from comment #28)
> This should be re-opened as it hasn't yet been properly fixed.

It is open.